package net.rumati.logging.muffero;

import net.rumati.logging.muffero.appender.Appender;

/**
 * A logger to use when there is an error in the logging system. Each {@link LoggerContext} has a
 * configured {@link LoggingErrorLogger} which {@link Appender}s should use to report errors
 * encountered performing logging.
 * @author Jesse Long
 * @see LoggerContext#getLoggingErrorLogger()
 */
public interface LoggingErrorLogger
{
    /**
     * Records an error encountered while performing normal logging operations.
     * @param message the message of the error
     * @param t the {@link Throwable} that caused the error
     */
    void logError(String message, Throwable t);
}
