package net.rumati.logging.muffero;

import java.util.Map;
import java.util.TreeMap;
import net.rumati.logging.muffero.util.ConservativeInheritableThreadLocal;

class MDCManager
{
    private final ConservativeInheritableThreadLocal<Map<String, String>> contextMaps = new ConservativeInheritableThreadLocal<Map<String, String>>()
    {
        @Override
        protected Map<String, String> create()
        {
            return new TreeMap<String, String>();
        }
    };

    MDCManager()
    {
    }

    void put(String key, String value)
    {
        contextMaps.get(true).put(key, value);
    }

    String get(String key)
    {
        Map<String, String> map = contextMaps.get();
        if (map == null){
            return null;
        }else{
            return map.get(key);
        }
    }

    void remove(String key)
    {
        Map<String, String> map = contextMaps.get();
        if (map == null){
            return;
        }

        map.remove(key);
        if (map.isEmpty()){
            contextMaps.remove();
        }
    }

    void clear()
    {
        contextMaps.remove();
    }

    Map<String, String> getCopyOfContextMap()
    {
        Map<String, String> map = contextMaps.get();
        if (map == null){
            return new TreeMap<String, String>();
        }else{
            return new TreeMap<String, String>(map);
        }
    }

    void setContextMap(Map<String, String> map)
    {
        contextMaps.get(true).putAll(map);
    }
}
