package net.rumati.logging.muffero.config;

import net.rumati.logging.muffero.layout.Layout;
import net.rumati.logging.muffero.LoggingException;
import net.rumati.logging.muffero.Priority;
import net.rumati.logging.muffero.LoggerFactory;
import net.rumati.logging.muffero.appender.ConsoleAppender;
import net.rumati.logging.muffero.appender.filter.PriorityFilteredAppender;
import net.rumati.logging.muffero.layout.PatternLayout;

public class BasicConfigurator
        extends Configurator
{
    private final Priority priority;
    private final Layout layout;

    public BasicConfigurator()
    {
        this(Priority.INFO);
    }

    public BasicConfigurator(Priority priority)
    {
        this.priority = priority;
        this.layout = new PatternLayout("%d [%thread] %-5priority %logger %mdc - %msg%n%ex");
    }

    @Override
    public void configure()
            throws LoggingException
    {
        addAppender(LoggerFactory.getRootLogger(), new PriorityFilteredAppender(new ConsoleAppender(layout), priority));
    }
}
